#!/usr/bin/env python
# Gimp-Python - allows the writing of Gimp plugins in Python.
#
# Python-Quick-Save - saves image file in chosen format
# Copyright (C) 2014  Bill Smith
#
# Redistribution and use in source and binary forms, with or without modification,
# are permitted provided that the following conditions are met:
#
#    - Redistributions of source code must retain the above copyright notice, this
#    list of conditions and the following disclaimer.
#    - Redistributions in binary form must reproduce the above copyright notice,
#    this list of conditions and the following disclaimer in the documentation and/or
#    other materials provided with the distribution.
#    - Neither the name of the author nor the names of its contributors may be used
#    to endorse or promote products derived from this software without specific prior
#    written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
# EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT
# SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
# TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
# BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
# ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
# DAMAGE.

from gimpfu import *

def python_quick_save(img, drawable):

    filename=pdb.gimp_image_get_filename(img)
    lst = len(filename)

    try:
        if(filename.lower().endswith(('.png'))):
            shortname = filename[0:lst-4]
            pdb.file_png_save(img, drawable, shortname + ".PNG", shortname + ".PNG",
                           1, 9, 0, 0, 0, 0, 0)
        elif(filename.lower().endswith(('.jpg'))):
            shortname = filename[0:lst-4]
            pdb.file_jpeg_save(img, drawable, shortname + ".JPG", shortname + ".JPG",
                           0.9, 0.0, 0, 0, "", 0, 0, 0, 0)
        elif(filename.lower().endswith(('.jpeg'))):
            shortname = filename[0:lst-5]
            pdb.file_jpeg_save(img, drawable, shortname + ".JPEG", shortname + ".JPEG",
                           0.9, 0.0, 0, 0, "", 0, 0, 0, 0)
        elif(filename.lower().endswith(('.bmp'))):
            shortname = filename[0:lst-4]
            pdb.file_bmp_save(img, drawable, shortname + ".BMP", shortname + ".BMP")
        elif(filename.lower().endswith(('.gif'))):
            shortname = filename[0:lst-4]
            pdb.file_gif_save(img, drawable, shortname + ".GIF", shortname + ".GIF",
                           0, 0, 0, 0)
        elif(filename.lower().endswith(('.tif'))):
            shortname = filename[0:lst-4]
            pdb.file_tiff_save(img, drawable, shortname + ".TIF", shortname + ".TIF",
                           0)
        elif(filename.lower().endswith(('.tiff'))):
            shortname = filename[0:lst-5]
            pdb.file_gif_save(img, drawable, shortname + ".TIFF", shortname + ".TIFF",
                           0)

    except Exception as err:
        gimp.message("Error : " + str(err))

register(
    "python_quick_save",
    "Save the image in chosen format",
    "Save the image as JPG, PNG, GIF, BMP or TIF",
    "Bill Smith",
    "Bill Smith",
    "2014",
    "<Image>/Py-Astro/Misc Tools/_Image quick save",
    "RGB*, GRAY*",
    [],
    [],
    python_quick_save,
    )

main()
